# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`storj_exporter`](#storj_exporter): This module manages Storj Exporter
* [`storj_exporter::install`](#storj_exporterinstall): This class install Storj exporter requirements and binaries.
* [`storj_exporter::service`](#storj_exporterservice): This class manages service

## Classes

### storj_exporter

Init class of Storj Exporter module. It can installes Storj Exporter binaries and single Service.

#### Examples

##### 

```puppet
include storj_exporter
```

#### Parameters

The following parameters are available in the `storj_exporter` class.

##### `version`

Data type: `Pattern[/\d+\.\d+\.\d+/]`

Storj exporter release. See https://github.com/anclrii/Storj-Exporter/releases

Default value: '0.2.5'

##### `base_dir`

Data type: `Stdlib::Absolutepath`

Base directory where Storj is extracted.

Default value: '/opt'

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: '/usr/local/bin'

##### `download_extension`

Data type: `String`

Extension of Storj exporter binaries archive.

Default value: 'tar.gz'

##### `download_url`

Data type: `Optional[Stdlib::HTTPUrl]`

Complete URL corresponding to the Storj exporter release, default to undef.

Default value: `undef`

##### `extract_command`

Data type: `Optional[String]`

Custom command passed to the archive resource to extract the downloaded archive.

Default value: `undef`

##### `manage_user`

Data type: `Boolean`

Whether to create user for storj_exporter or rely on external code for that.

Default value: `true`

##### `manage_group`

Data type: `Boolean`

Whether to create user for storj_exporter or rely on external code for that.

Default value: `true`

##### `user`

Data type: `String`

User running storj_exporter.

Default value: 'storj_exporter'

##### `group`

Data type: `String`

Group under which storj_exporter is running.

Default value: 'storj_exporter'

##### `usershell`

Data type: `Stdlib::Absolutepath`

if requested, we create a user for storj_exporter. The default shell is false. It can be overwritten to any valid path.

Default value: '/bin/false'

##### `extra_groups`

Data type: `Array[String]`

Add other groups to the managed user.

Default value: []

##### `service_ensure`

Data type: `Variant[Stdlib::Ensure::Service, Enum['absent']]`

State ensured from storj_exporter service.

Default value: 'running'

##### `port`

Data type: `Stdlib::Port`

Storj exporter port (required to be accessible).

Default value: 14002

##### `storj_host_address`

Data type: `Stdlib::Host`

Storj host address.

Default value: '127.0.0.1'

##### `storj_api_port`

Data type: `Stdlib::Port`

Storj api port.

Default value: 9651

##### `manage_python`

Data type: `Boolean`

Whether to install python3 or rely on external code for that.
Python3 is required to run exporter binary.

Default value: `true`

##### `python_required_packages`

Data type: `Array[String]`

Python required package list.

Default value: ['requests', 'prometheus_client']

##### `base_url`

Data type: `Stdlib::HTTPUrl`



Default value: 'https://github.com/anclrii/Storj-Exporter/archive'

### storj_exporter::install

This class install Storj exporter requirements and binaries.

#### Examples

##### 

```puppet
include storj_exporter::install
```

#### Parameters

The following parameters are available in the `storj_exporter::install` class.

##### `version`

Data type: `Pattern[/\d+\.\d+\.\d+/]`

Storj exporter release. See https://github.com/anclrii/Storj-Exporter/releases

Default value: $storj_exporter::version

##### `base_dir`

Data type: `Stdlib::Absolutepath`

Base directory where Storj is extracted.

Default value: $storj_exporter::base_dir

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: $storj_exporter::bin_dir

##### `download_extension`

Data type: `String`

Extension of Storj exporter binaries archive.

Default value: $storj_exporter::download_extension

##### `download_url`

Data type: `Stdlib::HTTPUrl`

Complete URL corresponding to the Storj exporter release, default to undef.

Default value: $storj_exporter::real_download_url

##### `extract_command`

Data type: `Optional[String]`

Custom command passed to the archive resource to extract the downloaded archive.

Default value: $storj_exporter::extract_command

##### `manage_user`

Data type: `Boolean`

Whether to create user for storj_exporter or rely on external code for that.

Default value: $storj_exporter::manage_user

##### `manage_group`

Data type: `Boolean`

Whether to create user for storj_exporter or rely on external code for that.

Default value: $storj_exporter::manage_group

##### `user`

Data type: `String`

User running storj_exporter.

Default value: $storj_exporter::user

##### `group`

Data type: `String`

Group under which storj_exporter is running.

Default value: $storj_exporter::group

##### `usershell`

Data type: `Stdlib::Absolutepath`

if requested, we create a user for storj_exporter. The default shell is false. It can be overwritten to any valid path.

Default value: $storj_exporter::usershell

##### `extra_groups`

Data type: `Array[String]`

Add other groups to the managed user.

Default value: $storj_exporter::extra_groups

##### `python_required_packages`

Data type: `Array[String]`

Python required package list.

Default value: $storj_exporter::python_required_packages

### storj_exporter::service

This class manages service

#### Examples

##### 

```puppet
include storj_exporter::service
```

#### Parameters

The following parameters are available in the `storj_exporter::service` class.

##### `ensure`

Data type: `Variant[Stdlib::Ensure::Service, Enum['absent']]`

State ensured from storj_exporter service.

Default value: $storj_exporter::service_ensure

##### `user`

Data type: `String`

User running storj_exporter.

Default value: $storj_exporter::user

##### `group`

Data type: `String`

Group under which storj_exporter is running.

Default value: $storj_exporter::group

##### `port`

Data type: `Stdlib::Port`

Storj exporter port (required to be accessible).

Default value: $storj_exporter::port

##### `storj_host_address`

Data type: `Stdlib::Host`

Storj host address.

Default value: $storj_exporter::storj_host_address

##### `storj_api_port`

Data type: `Stdlib::Port`

Storj api port.

Default value: $storj_exporter::storj_api_port

##### `bin_dir`

Data type: `Stdlib::Absolutepath`

Directory where binaries are located.

Default value: $storj_exporter::bin_dir

